diff -uwr source/scripts/jfwdmg.h 4.0/source/scripts/jfwdmg.h
--- source/scripts/jfwdmg.h	2011-06-17 14:06:30.000000000 +0800
+++ 4.0/source/scripts/jfwdmg.h	2011-10-14 22:27:32.069335900 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts to do with death, damage and health
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Spawn_Object_Death : public ScriptImpClass {
 	void Killed(GameObject *obj,GameObject *killer);
 };
diff -uwr source/scripts/jfwgame.cpp 4.0/source/scripts/jfwgame.cpp
--- source/scripts/jfwgame.cpp	2011-05-20 19:17:24.000000000 +0800
+++ 4.0/source/scripts/jfwgame.cpp	2011-10-22 20:22:09.983398400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for major gameplay elements (including scripts for specific buildings, units etc)
-	Copyright 2010 Vloktboky, E!, Jonathan Wilson, Joshua "NeoSaber" Kraft, zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwgame.h 4.0/source/scripts/jfwgame.h
--- source/scripts/jfwgame.h	2011-04-30 15:36:08.000000000 +0800
+++ 4.0/source/scripts/jfwgame.h	2011-10-14 22:27:32.040039000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for major gameplay elements (including scripts for specific buildings, units etc)
-	Copyright 2010 Vloktboky, E!, Jonathan Wilson, Joshua "NeoSaber" Kraft, zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Team_DM_Zone : public ScriptImpClass {
 	bool triggered;
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
diff -uwr source/scripts/jfwgun.cpp 4.0/source/scripts/jfwgun.cpp
--- source/scripts/jfwgun.cpp	2010-05-25 21:17:30.000000000 +0800
+++ 4.0/source/scripts/jfwgun.cpp	2011-10-11 23:05:13.274414000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Building gun scripts
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwgun.h 4.0/source/scripts/jfwgun.h
--- source/scripts/jfwgun.h	2010-05-21 09:42:38.000000000 +0800
+++ 4.0/source/scripts/jfwgun.h	2011-10-14 22:27:32.115234300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Building gun scripts
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Building_Gun : public ScriptImpClass {
 	int weaponid;
 	void Created(GameObject *obj);
diff -uwr source/scripts/jfwhook.cpp 4.0/source/scripts/jfwhook.cpp
--- source/scripts/jfwhook.cpp	2010-05-21 09:42:38.000000000 +0800
+++ 4.0/source/scripts/jfwhook.cpp	2011-10-11 23:05:12.082031200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Hook scripts
-	Copyright 2010 TheKGBspy, Jonathan Wilson, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwhook.h 4.0/source/scripts/jfwhook.h
--- source/scripts/jfwhook.h	2010-05-21 09:42:38.000000000 +0800
+++ 4.0/source/scripts/jfwhook.h	2011-10-14 22:27:32.037109300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Hook scripts
-	Copyright 2010 TheKGBspy, Jonathan Wilson, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 void ObjectCreateHookBaseHook(void *data,GameObject *obj);
 
 void KeyHookBaseHook(void *data);
diff -uwr source/scripts/jfwmisc.cpp 4.0/source/scripts/jfwmisc.cpp
--- source/scripts/jfwmisc.cpp	2011-02-18 22:55:26.000000000 +0800
+++ 4.0/source/scripts/jfwmisc.cpp	2011-10-25 15:38:28.286132800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Miscellanious scripts
-	Copyright 2010 Vloktboky, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -19,6 +18,15 @@
 #include "TeamPurchaseSettingsDefClass.h"
 #include "PurchaseSettingsDefClass.h"
 #include "BuildingGameObjDef.h"
+#include "ConstructionYardGameObj.h"
+#include "RefineryGameObj.h"
+#include "ArmorWarheadManager.h"
+#include "VehicleGameObj.h"
+#include "WeaponClass.h"
+#include "VehicleFactoryGameObj.h"
+#include "AirFactoryGameObj.h"
+#include "PurchaseSettingsDefClass.h"
+
 void JFW_User_Settable_Parameters::Created(GameObject *obj)
 {
 	const char *filename;
@@ -981,6 +989,628 @@
 	}
 }
 
+void JFW_Display_String_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("Message"))
+	{
+		const char *string = Get_Parameter("String");
+		const char *sound = Get_Parameter("Sound");
+		int red = Get_Int_Parameter("Red");
+		int green = Get_Int_Parameter("Green");
+		int blue = Get_Int_Parameter("Blue");
+		int team = Get_Int_Parameter("Team");
+		Send_Message_Team(team,red,green,blue,string);
+		Create_2D_Sound_Team(sound,team);
+	}
+}
+
+void JFW_Preset_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_Preset_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("Disable_Custom"))
+	{
+		if (count == 0)
+		{
+			Disable_Preset_By_Name(Commands->Get_Player_Type(obj),Get_Parameter("Preset"),true);
+		}
+		count++;
+	}
+	if (type == Get_Int_Parameter("Enable_Custom"))
+	{
+		count--;
+		if (count == 0)
+		{
+			Disable_Preset_By_Name(Commands->Get_Player_Type(obj),Get_Parameter("Preset"),false);
+		}
+	}
+}
+
+void JFW_Preset_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_Power_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_Power_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("Disable_Custom"))
+	{
+		if (count == 0)
+		{
+			Power_Base(Commands->Get_Player_Type(obj),false);
+		}
+		count++;
+	}
+	if (type == Get_Int_Parameter("Enable_Custom"))
+	{
+		count--;
+		if (count == 0)
+		{
+			Power_Base(Commands->Get_Player_Type(obj),true);
+		}
+	}
+}
+
+void JFW_Power_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_Radar_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_Radar_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("Disable_Custom"))
+	{
+		if (count == 0)
+		{
+			Enable_Base_Radar(Get_Object_Type(obj),false);
+		}
+		count++;
+	}
+	if (type == Get_Int_Parameter("Enable_Custom"))
+	{
+		count--;
+		if (count == 0)
+		{
+			Enable_Base_Radar(Get_Object_Type(obj),true);
+		}
+	}
+}
+
+void JFW_Radar_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_Conyard_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_Conyard_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_ConstructionYardGameObj())
+	{
+		if (type == Get_Int_Parameter("Disable_Custom"))
+		{
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_ConstructionYardGameObj()->Set_Spy(true);
+			}
+			count++;
+		}
+		if (type == Get_Int_Parameter("Enable_Custom"))
+		{
+			count--;
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_ConstructionYardGameObj()->Set_Spy(false);
+			}
+		}
+	}
+}
+
+void JFW_Conyard_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_Refinery_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_Refinery_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_RefineryGameObj())
+	{
+		if (type == Get_Int_Parameter("Disable_Custom"))
+		{
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_RefineryGameObj()->Block_Harvester_Spawn();
+			}
+			count++;
+		}
+		if (type == Get_Int_Parameter("Enable_Custom"))
+		{
+			count--;
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_RefineryGameObj()->Allow_Harvester_Spawn();
+			}
+		}
+	}
+}
+
+void JFW_Refinery_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_VehicleFactory_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_VehicleFactory_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_VehicleFactoryGameObj())
+	{
+		if (type == Get_Int_Parameter("Disable_Custom"))
+		{
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_VehicleFactoryGameObj()->Set_Disabled(true);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(true);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(true);
+			}
+			count++;
+		}
+		if (type == Get_Int_Parameter("Enable_Custom"))
+		{
+			count--;
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_VehicleFactoryGameObj()->Set_Disabled(false);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(false);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(false);
+			}
+		}
+	}
+}
+
+void JFW_VehicleFactory_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_AirFactory_Disable::Created(GameObject *obj)
+{
+	count = 0;
+}
+
+void JFW_AirFactory_Disable::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_AirFactoryGameObj())
+	{
+		if (type == Get_Int_Parameter("Disable_Custom"))
+		{
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_AirFactoryGameObj()->Set_Disabled(true);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(true);
+			}
+			count++;
+		}
+		if (type == Get_Int_Parameter("Enable_Custom"))
+		{
+			count--;
+			if (count == 0)
+			{
+				obj->As_BuildingGameObj()->As_AirFactoryGameObj()->Set_Disabled(false);
+				PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,(PurchaseSettingsDefClass::TEAM)PTTEAM(Get_Object_Type(obj)))->Set_Page_Disabled(false);
+			}
+		}
+	}
+}
+
+void JFW_AirFactory_Disable::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+
+void JFW_Engineer_Hack::Created(GameObject *obj)
+{
+	Warhead = ArmorWarheadManager::Get_Warhead_Type(Get_Parameter("Hack_Warhead"));
+	HackHealth = Get_Float_Parameter("Hack_Health");
+	IndcatorID = Commands->Get_ID(Find_Nearest_Preset(Commands->Get_Position(obj),Get_Parameter("Hack_Indicator_Preset")));
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("Hack_Restore_Timer"),1);
+}
+void JFW_Engineer_Hack::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroy_Script();
+}
+void JFW_Engineer_Hack::Damaged(GameObject *obj,GameObject *damager,float amount)
+{
+	if (Warhead == Get_Damage_Warhead())
+	{
+		if (Commands->Get_Player_Type(obj) == Commands->Get_Player_Type(damager))
+		{
+			Apply_Repair(obj,Get_Float_Parameter("Hack_Repair"));
+		}
+		else
+		{
+			Apply_Damage(obj,Get_Float_Parameter("Hack_Damage"));
+		}
+	}
+}
+void JFW_Engineer_Hack::Timer_Expired(GameObject *obj,int number)
+{
+	Apply_Repair(obj,Get_Float_Parameter("Hack_Restore_Amount"));
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("Hack_Restore_Timer"),1);
+}
+void JFW_Engineer_Hack::Apply_Damage(GameObject *obj,float damage)
+{
+	float oldhealth = HackHealth;
+	HackHealth -= damage;
+	float offline = Get_Float_Parameter("Hack_Offline_Amount");
+	if (HackHealth <= 0)
+	{
+		Commands->Apply_Damage(obj,99999,"Death",0);
+	}
+	if (oldhealth > offline && HackHealth <= offline)
+	{
+		Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Hack_Offline_Custom"),0,0);
+		Commands->Send_Custom_Event(Commands->Find_Object(IndcatorID),obj,Get_Int_Parameter("Hack_Offline_Custom"),0,0);
+	}
+}
+void JFW_Engineer_Hack::Apply_Repair(GameObject *obj,float repair)
+{
+	float oldhealth = HackHealth;
+	HackHealth += repair;
+	if (HackHealth > Get_Float_Parameter("Hack_Health"))
+	{
+		HackHealth = Get_Float_Parameter("Hack_Health");
+	}
+	float offline = Get_Float_Parameter("Hack_Offline_Amount");
+	if (oldhealth <= offline && HackHealth > offline)
+	{
+		Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Hack_Online_Custom"),0,0);
+		Commands->Send_Custom_Event(Commands->Find_Object(IndcatorID),obj,Get_Int_Parameter("Hack_Online_Custom"),0,0);
+	}
+}
+
+void JFW_Double_Animation::Created(GameObject *obj)
+{
+	StringClass str = Get_Model(obj);
+	str += ".";
+	str += Get_Model(obj);
+	Commands->Set_Animation(obj,str,0,0,0,Get_Float_Parameter("End_Frame"),0);
+}
+void JFW_Double_Animation::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == Get_Int_Parameter("First_Custom"))
+	{
+		StringClass str = Get_Model(obj);
+		str += ".";
+		str += Get_Model(obj);
+		Commands->Set_Animation(obj,str,0,0,0,Get_Float_Parameter("End_Frame"),0);
+	}
+	if (type == Get_Int_Parameter("Second_Custom"))
+	{
+		StringClass str = Get_Model(obj);
+		str += ".";
+		str += Get_Model(obj);
+		Commands->Set_Animation(obj,str,0,0,Get_Float_Parameter("End_Frame")+1,-1,0);
+	}
+}
+
+void JFW_EMP::Created(GameObject *obj)
+{
+	Warhead = ArmorWarheadManager::Get_Warhead_Type(Get_Parameter("Warhead"));
+}
+
+void JFW_EMP::Damaged(GameObject *obj,GameObject *damager,float amount)
+{
+	if (Warhead == Get_Damage_Warhead())
+	{
+		VehicleGameObj *o = obj->As_VehicleGameObj();
+		if (o && o->Get_Is_Scripts_Visible() && !o->Is_Immovable())
+		{
+			o->Set_Immovable(true);
+			o->Set_Scripts_Can_Fire(false);
+			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
+			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,0,-1,false);
+			obj->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
+		}
+	}
+}
+
+void JFW_EMP::Timer_Expired(GameObject *obj,int number)
+{
+	VehicleGameObj *o = obj->As_VehicleGameObj();
+	Commands->Set_Animation(obj,0,true,0,0,-1,false);
+	obj->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE,true);
+	o->Set_Immovable(false);
+	o->Set_Scripts_Can_Fire(true);
+}
+
+void JFW_EMP_Mine::Created(GameObject *obj)
+{
+	Commands->Enable_Hibernation(obj,false);
+	Commands->Innate_Enable(obj);
+	Commands->Enable_Enemy_Seen(obj,true);
+}
+
+void JFW_EMP_Mine::Enemy_Seen(GameObject *obj, GameObject *enemy)
+{
+	Commands->Create_Explosion(Get_Parameter("Explosion"),Commands->Get_Position(obj),0);
+	Commands->Apply_Damage(obj,99999,"Death",0);
+}
+
+void JFW_EMP_Mine::Destroyed(GameObject *obj)
+{
+	Commands->Send_Custom_Event(obj, Commands->Find_Object(Get_Int_Parameter("Mine_Manager_ID")),111111,0,0);
+}
+
+void JFW_EMP_Mine_Manager::Created(GameObject *obj)
+{
+	mines = 0;
+}
+
+void JFW_EMP_Mine_Manager::Custom(GameObject *obj, int type, int param, GameObject *sender)
+{
+	if (type == 111111)
+	{
+		mines--;
+	}
+	else if (type == 222222)
+	{
+		int limit = Get_Int_Parameter("Mine_Limit");
+		if (mines < limit)
+		{
+			mines++;
+			SoldierGameObj *s = sender->As_SoldierGameObj();
+			if (s)
+			{
+				GameObject *mine = Commands->Create_Object(Get_Parameter("Mine_Preset"),s->Get_Muzzle().Get_Translation());
+				PhysicalGameObj *p = mine->As_PhysicalGameObj();
+				p->Peek_Physical_Object()->Set_Collision_Group(TERRAIN_AND_BULLET_COLLISION_GROUP);
+			}
+		}
+		else
+		{
+			Commands->Give_PowerUp(sender, Get_Parameter("Mine_Reload"), false);
+		}
+	}
+}
+
+void JFW_EMP_Mine_Layer::Damaged(GameObject *obj, GameObject *damager, float amount)
+{
+	unsigned int warhead = ArmorWarheadManager::Get_Warhead_Type(Get_Parameter("Warhead"));
+	if (warhead == Get_Damage_Warhead() && damager == obj)
+	{
+		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Mine_Manager_ID")), 222222,0,0);
+	}
+}
+
+void JFW_Radar_Disable_Death::Killed(GameObject *obj,GameObject *killer)
+{
+	Enable_Base_Radar(Get_Object_Type(obj),false);
+}
+
+void JFW_Cyborg_Reaper::Created(GameObject *obj)
+{
+	driverid = 0;
+}
+
+void JFW_Cyborg_Reaper::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		Commands->Apply_Damage(obj,99999,"Death",0);
+		Commands->Attach_Script(Commands->Find_Object(driverid),"RA_DriverDeath", "0");
+	}
+	else if (type == CUSTOM_EVENT_VEHICLE_OWNER)
+	{
+		Commands->Set_Position(obj,Commands->Get_Position(sender));
+		Soldier_Transition_Vehicle(sender);
+		driverid = Commands->Get_ID(sender);
+	}
+}
+
+void JFW_Cyborg_Reaper::Killed(GameObject *obj,GameObject *killer)
+{
+	Commands->Attach_Script(Commands->Find_Object(driverid),"RA_DriverDeath", "0");
+}
+
+void JFW_Limpet_Drone::Created(GameObject *obj)
+{
+	stealth = false;
+	if (obj->As_VehicleGameObj())
+	{
+		obj->As_VehicleGameObj()->Set_Is_Scripts_Visible(false);
+	}
+}
+
+void JFW_Limpet_Drone::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == 923572385)
+	{
+		stealth = !stealth;
+		Commands->Enable_Stealth(obj,stealth);
+	}
+}
+
+void JFW_Forward_Custom_Object::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Object_ID")),type,param,0);
+}
+
+void JFW_Death_Send_Custom_Self::Killed(GameObject *obj,GameObject *killer)
+{
+	Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),0,0);
+}
+
+void JFW_Hunter_Seeker::Created(GameObject *obj)
+{
+	InstallHook(Get_Parameter("Key"),obj);
+	driverid = 0;
+}
+
+void JFW_Hunter_Seeker::KeyHook()
+{
+	Commands->Start_Timer(Owner(),this,5,1);
+	Soldier_Transition_Vehicle(Commands->Find_Object(driverid));
+}
+
+void JFW_Hunter_Seeker::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		Commands->Start_Timer(obj,this,5,2);
+	}
+	else if (type == CUSTOM_EVENT_VEHICLE_OWNER)
+	{
+		driverid = Commands->Get_ID(sender);
+	}
+}
+
+void JFW_Hunter_Seeker::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		Commands->Apply_Damage(obj,99999,"Death",0);
+		Commands->Create_Explosion(Get_Parameter("Explosion"),Commands->Get_Position(obj),0);
+	}
+	else if (number == 2)
+	{
+		Commands->Apply_Damage(obj,99999,"Death",0);
+	}
+}
+
+void JFW_Ion_Storm::Created(GameObject *obj)
+{
+	storm = false;
+	float min = Get_Float_Parameter("Min_Delay");
+	float max = Get_Float_Parameter("Max_Delay");
+	if (max > The_Game()->Get_Time_Remaining_Seconds())
+	{
+		max = The_Game()->Get_Time_Remaining_Seconds();
+	}
+	if (min > The_Game()->Get_Time_Remaining_Seconds())
+	{
+		Destroy_Script();
+	}
+	float timer = Commands->Get_Random(min,max);
+	Commands->Start_Timer(obj,this,timer,1);
+}
+void JFW_Ion_Storm::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1) //start storm
+	{
+		storm = true;
+		float min = Get_Float_Parameter("Min_Time");
+		float max = Get_Float_Parameter("Max_Time");
+		if (max > The_Game()->Get_Time_Remaining_Seconds())
+		{
+			max = The_Game()->Get_Time_Remaining_Seconds();
+		}
+		if (min > The_Game()->Get_Time_Remaining_Seconds())
+		{
+			Destroy_Script();
+		}
+		float timer = Commands->Get_Random(min,max);
+		Commands->Start_Timer(obj,this,timer,2);
+		Commands->Set_Lightning(Get_Float_Parameter("Lightning_Intensity"),Get_Float_Parameter("Lightning_Start_Distance"),Get_Float_Parameter("Lightning_End_Distance"),Get_Float_Parameter("Lightning_Heading"),Get_Float_Parameter("Lightning_Distribution"),0);
+		if (Find_Building(0,BuildingConstants::TYPE_COM_CENTER))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
+		}
+		if (Find_Building(1,BuildingConstants::TYPE_COM_CENTER))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Disable_Custom"),0,0);
+		}
+		if (Find_Building(0,BuildingConstants::TYPE_POWER_PLANT))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
+		}
+		if (Find_Building(1,BuildingConstants::TYPE_POWER_PLANT))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Disable_Custom"),0,0);
+		}
+		Timer_Expired(obj,3);
+		Create_2D_Sound_Team(Get_Parameter("Announcement_Sound_Nod"),0);
+		Create_2D_Sound_Team(Get_Parameter("Announcement_Sound_GDI"),1);
+		const char *string = Get_Parameter("Announcement_String");
+		int red = Get_Int_Parameter("Red");
+		int green = Get_Int_Parameter("Green");
+		int blue = Get_Int_Parameter("Blue");
+		Send_Message(red,green,blue,string);
+	}
+	else if (number == 2) //storm ended
+	{
+		storm = false;
+		Commands->Set_Lightning(Get_Float_Parameter("Lightning_Off_Intensity"),Get_Float_Parameter("Lightning_Off_Start_Distance"),Get_Float_Parameter("Lightning_Off_End_Distance"),Get_Float_Parameter("Lightning_Off_Heading"),Get_Float_Parameter("Lightning_Off_Distribution"),0);
+		if (Find_Building(0,BuildingConstants::TYPE_COM_CENTER))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
+		}
+		if (Find_Building(1,BuildingConstants::TYPE_COM_CENTER))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_COM_CENTER),Get_Int_Parameter("Enable_Custom"),0,0);
+		}
+		if (Find_Building(0,BuildingConstants::TYPE_POWER_PLANT))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(0,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
+		}
+		if (Find_Building(1,BuildingConstants::TYPE_POWER_PLANT))
+		{
+			Commands->Send_Custom_Event(obj,Find_Building(1,BuildingConstants::TYPE_POWER_PLANT),Get_Int_Parameter("Enable_Custom"),0,0);
+		}
+		Create_2D_Sound_Team(Get_Parameter("End_Announcement_Sound_Nod"),0);
+		Create_2D_Sound_Team(Get_Parameter("End_Announcement_Sound_GDI"),1);
+		const char *string = Get_Parameter("End_Announcement_String");
+		int red = Get_Int_Parameter("Red");
+		int green = Get_Int_Parameter("Green");
+		int blue = Get_Int_Parameter("Blue");
+		Send_Message(red,green,blue,string);
+		float min = Get_Float_Parameter("Min_Delay");
+		float max = Get_Float_Parameter("Max_Delay");
+		if (max > The_Game()->Get_Time_Remaining_Seconds())
+		{
+			max = The_Game()->Get_Time_Remaining_Seconds();
+		}
+		if (min > The_Game()->Get_Time_Remaining_Seconds())
+		{
+			Destroy_Script();
+		}
+		float timer = Commands->Get_Random(min,max);
+		Commands->Start_Timer(obj,this,timer,1);
+	}
+	else if (number == 3)
+	{
+		if (storm)
+		{
+			Commands->Create_2D_Sound(Get_Parameter("Ion_Effect_Sound"));
+			Commands->Start_Timer(obj,this,Get_Float_Parameter("Ion_Effect_Time"),3);
+		}
+	}
+}
+
 ScriptRegistrant<JFW_Stealthable_Object> JFW_Stealthable_Object_Registrant("JFW_Stealthable_Object","Message:int");
 ScriptRegistrant<JFW_Object_Counter> JFW_Object_Counter_Registrant("JFW_Object_Counter","Count:int,IncrementMessage:int,DecrementMessage:int");
 ScriptRegistrant<JFW_Fog_Create> JFW_Fog_Create_Registrant("JFW_Fog_Create","Fog_Enable:int,Fog_Start_Distance=0.000:float,Fog_End_Distance=0.000:float,Delay=0.000:float,OnCreate=0:int,OnDestroy=0:int");
@@ -1034,3 +1664,24 @@
 ScriptRegistrant<JFW_Game_Hint_Image_Zone> JFW_Game_Hint_Image_Zone_Registrant("JFW_Game_Hint_Image_Zone","Player_Type:int,EventID:int,Sound:string,TitleID:int,TextID:int,TextID2:int,TextID3:int,Texture:string");
 ScriptRegistrant<JFW_Moon_Is_Earth> JFW_Moon_Is_Earth_Registrant("JFW_Moon_Is_Earth","");
 ScriptRegistrant<JFW_Points_Custom> JFW_Points_Custom_Registrant("JFW_Points_Custom","Message:int,Points:int,Team:int");
+ScriptRegistrant<JFW_Engineer_Hack> JFW_Engineer_Hack_Registrant("JFW_Engineer_Hack","Hack_Warhead:string,Hack_Health:float,Hack_Damage:float,Hack_Repair:float,Hack_Restore_Timer:float,Hack_Restore_Amount:float,Hack_Offline_Amount:float,Hack_Offline_Custom:int,Hack_Online_Custom:int,Hack_Indicator_Preset:string");
+ScriptRegistrant<JFW_Double_Animation> JFW_Double_Animation_Registrant("JFW_Double_Animation","End_Frame:float,First_Custom:int,Second_Custom:int");
+ScriptRegistrant<JFW_Display_String_Custom> JFW_Display_String_Custom_Registrant("JFW_Display_String_Custom","Message:int,Team:int,String:string,Sound:string,Red:int,Green:int,Blue:int");
+ScriptRegistrant<JFW_Preset_Disable> JFW_Preset_Disable_Registrant("JFW_Preset_Disable","Preset:string,Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_Power_Disable> JFW_Power_Disable_Registrant("JFW_Power_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_Radar_Disable> JFW_Radar_Disable_Registrant("JFW_Radar_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_Conyard_Disable> JFW_Conyard_Disable_Registrant("JFW_Conyard_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_Refinery_Disable> JFW_Refinery_Disable_Registrant("JFW_Refinery_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_VehicleFactory_Disable> JFW_VehicleFactory_Disable_Registrant("JFW_VehicleFactory_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_AirFactory_Disable> JFW_AirFactory_Disable_Registrant("JFW_AirFactory_Disable","Disable_Custom:int,Enable_Custom:int");
+ScriptRegistrant<JFW_EMP> JFW_EMP_Registrant("JFW_EMP","Warhead:string,Time:fload,Animation:string");
+ScriptRegistrant<JFW_EMP_Mine> JFW_EMP_Mine_Registrant("JFW_EMP_Mine","Mine_Manager_ID:int,Explosion:string");
+ScriptRegistrant<JFW_EMP_Mine_Manager> JFW_EMP_Mine_Manager_Registrant("JFW_EMP_Mine_Manager","Mine_Preset:string,Mine_Limit:int,Mine_Reload:string");
+ScriptRegistrant<JFW_EMP_Mine_Layer> JFW_EMP_Mine_Layer_Registrant("JFW_EMP_Mine_Layer","Mine_Manager_ID:int,Warhead:string");
+ScriptRegistrant<JFW_Radar_Disable_Death> JFW_Radar_Disable_Death_Registrant("JFW_Radar_Disable_Death","");
+ScriptRegistrant<JFW_Cyborg_Reaper> JFW_Cyborg_Reaper_Registrant("JFW_Cyborg_Reaper","");
+ScriptRegistrant<JFW_Limpet_Drone> JFW_Limpet_Drone_Registrant("JFW_Limpet_Drone","");
+ScriptRegistrant<JFW_Forward_Custom_Object> JFW_Forward_Custom_Object_Registrant("JFW_Forward_Custom_Object","Object_ID:int");
+ScriptRegistrant<JFW_Death_Send_Custom_Self> JFW_Death_Send_Custom_Self_Registrant("JFW_Death_Send_Custom_Self","Message:int");
+ScriptRegistrant<JFW_Hunter_Seeker> JFW_Hunter_Seeker_Registrant("JFW_Hunter_Seeker","Key:string,Explosion:string");
+ScriptRegistrant<JFW_Ion_Storm> JFW_Ion_Storm_Registrant("JFW_Ion_Storm","Min_Delay:float,Max_Delay:float,Min_Time:float,Max_Time:float,Disable_Custom:int,Enable_Custom:int,Announcement_Sound_Nod:string,Announcement_Sound_GDI:string,Announcement_String:string,Red:int,Green:int,Blue:int,Ion_Effect_Sound:string,Ion_Effect_Time:float,Lightning_Intensity:float,Lightning_Start_Distance:float,Lightning_End_Distance:float,Lightning_Heading:float,Lightning_Distribution:float,Lightning_Off_Intensity:float,Lightning_Off_Start_Distance:float,Lightning_Off_End_Distance:float,Lightning_Off_Heading:float,Lightning_Off_Distribution:float,End_Announcement_Sound_Nod:string,End_Announcement_Sound_GDI:string,End_Announcement_String:string");
